SystemOrganization addCategory: #'Glamour-Seaside-Core'!
SystemOrganization addCategory: #'Glamour-Seaside-Examples'!

!Symbol methodsFor: '*glamour-seaside' stamp: 'lr 2/25/2009 16:10'!
fixCallbackTemps! !

WAComponent subclass: #SGLComponent
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Core'!

!SGLComponent classSide methodsFor: 'initialization' stamp: 'lr 2/26/2009 19:52'!
registerAsApplication: aString
	| application |
	application := WAAdmin register: self asApplicationAt: aString.
	application configuration
		addParent: WADevelopmentConfiguration instance.
	application addLibrary: JQDeploymentLibrary.
	^ application! !

!SGLComponent methodsFor: 'accessing' stamp: 'lr 2/26/2009 20:36'!
browser
	"Override this method and answer a browser instance."
	
	self subclassResponsibility! !

!SGLComponent methodsFor: 'accessing' stamp: 'lr 2/26/2009 20:59'!
model
	"Override this method and answer a model instance."
	
	self subclassResponsibility! !

!SGLComponent methodsFor: 'private' stamp: 'lr 2/27/2009 10:13'!
presentation
	presentation isNil ifTrue: [
		presentation := self browser 
			startOn: self model;
			yourself ].
	^ presentation! !

!SGLComponent methodsFor: 'rendering' stamp: 'lr 2/27/2009 10:14'!
renderContentOn: html
	(SGLRenderer in: self on: html)
		render: self presentation! !

!SGLComponent methodsFor: 'accessing' stamp: 'lr 2/27/2009 11:06'!
style
	"Theme: http://kuler.adobe.com/#themeID/375397"

	^ 'body {
	color: #f6feff;
	background-color: #201e18;
	font-family: "Helvetica Neue", Helvetica, Arial;
	font-size: 14px;
}
a {
	color: #f5b741;
	text-decoration: none;
}
	
::-moz-selection {
	color: #f6feff;
	background-color: #f5b741;
}
::selection {
	color: #f6feff;
	background-color: #f5b741;
}

table { width: 100%; }
table td { vertical-align: top; }

select {
	width: 100%;
	height: 100%;
	outline: none;
	border: #444039 solid 1px;
	color: inherit;
	background-color: inherit;
}
textarea {
	width: 100%;
	height: 100%;
	outline: none;
	border: #444039 solid 1px;
	color: inherit;
	background-color: inherit;
}

ul.tabs li.tabs-current {
	font-weight: bold;
}
'! !

!SGLComponent methodsFor: 'updating' stamp: 'lr 2/26/2009 20:26'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot title: 'Seaside Glamorous Browser'! !

SGLComponent subclass: #SGLFileBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLFileBrowser classSide methodsFor: 'initialization' stamp: 'lr 2/27/2009 09:25'!
initialize
	self registerAsApplication: 'glamour/file'! !

!SGLFileBrowser methodsFor: 'accessing' stamp: 'lr 2/27/2009 09:25'!
browser
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser 
		column: #folders;
		column: [ :c | c row: #files span: 2; row: #summary ] span: 2.

	browser showOn: #folders; using: [
		browser tree 
			title: 'Folders'; 
			children: [ :directory | 
				directory directoryNames
					collect: [ :each | directory directoryNamed: each ] ];
			format: [ :directory | directory localName ] ].

	browser showOn: #files; from: #folders; using: [
		browser list
			display: [ :directory | 
				directory fileNames
					collect: [ :each | directory directoryNamed: each ] ];
			format: [ :directory | directory localName ] ].

	browser showOn: #summary; from: #files; using: [
		browser text 
			title: 'Summary';
			display: [ :directory |
				| stream |
				stream := FileStream oldFileNamed: directory pathName.
				[ stream contents ] ensure: [ stream close ] ] ].

	^ browser! !

!SGLFileBrowser methodsFor: 'accessing' stamp: 'lr 2/27/2009 09:19'!
model
	^ FileDirectory default! !

SGLComponent subclass: #SGLPackageBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLPackageBrowser classSide methodsFor: 'initialization' stamp: 'lr 2/27/2009 09:25'!
initialize
	self registerAsApplication: 'glamour/package'! !

!SGLPackageBrowser methodsFor: 'accessing' stamp: 'lr 2/27/2009 11:00'!
browser
	| browser |
	
	" browser "
	browser := GLMTableLayoutBrowser new.
	browser column: #category; column: #class; column: #protocol; column: #selector.
	browser column: #source.
	
	" categories "
	browser showOn: #category; using: [
		browser list
			display: [ :environment | environment categories ] ].

	" classes "
	browser showOn: #class; from: #outer -> #entity; from: #category; using: [
		browser list
			title: 'Instance';
			display: [ :environment :category | 
				((environment classes select: [ :each | each isMeta not ])
					select: [ :each | each category = category ])
					asSortedCollection: [ :a :b | a name < b name ] ];
			format: [ :class | class name ].
		browser list
			title: 'Class';
			display: [ :environment :category | 
				((environment classes select: [ :each | each isMeta ])
					select: [ :each | each theNonMetaClass category = category ])
					asSortedCollection: [ :a :b | a name < b name ] ];
			format: [ :class | class theNonMetaClass name ] ].

	" protocols "
	browser showOn: #protocol; from: #outer -> #entity; from: #class; using: [
		browser list
			when: [ :environment :class | class notNil ];
			display: [ :environment :class | 
				(environment protocolsFor: class)
					asSortedCollection ] ].

	" selectors " 
	browser showOn: #selector; from: #outer -> #entity; from: #class; from: #protocol; using: [
		browser list
			when: [ :environment :class :protocol | class notNil and: [ protocol notNil ] ];
			display: [ :environment :class :protocol | environment selectorsFor: protocol in: class ].
		browser list
			when: [ :environment :class :protocol | class notNil and: [ protocol isNil ] ];
			display: [ :environment :class :protocol | environment selectorsForClass: class ] ].
		
	" source "
	browser showOn: #source; from: #class; from: #selector; using: [
		browser text
			when: [ :class :selector | selector notNil ];
			display: [ :class :selector | class sourceCodeAt: selector ].
		browser text
			when: [ :class :selector | selector isNil ];
			display: [ :class :selector | class definition ] ].

	^ browser! !

!SGLPackageBrowser methodsFor: 'accessing' stamp: 'lr 2/27/2009 10:35'!
model
	^ BrowserEnvironment new forPackageNamed: 'Glamour'! !

GLMRenderer subclass: #SGLRenderer
	instanceVariableNames: 'component html uuid scripts properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Core'!

!SGLRenderer classSide methodsFor: 'instance-creation' stamp: 'lr 2/26/2009 19:58'!
in: aComponent on: html
	^ self basicNew initializeIn: aComponent on: html! !

!SGLRenderer methodsFor: 'opening' stamp: 'lr 2/26/2009 22:50'!
doOpen: anObject
	^ anObject! !

!SGLRenderer methodsFor: 'initialization' stamp: 'lr 2/27/2009 10:23'!
initialize
	super initialize.
	uuid := IdentityDictionary new.
	scripts := OrderedCollection new.
	properties := IdentityDictionary new! !

!SGLRenderer methodsFor: 'initialization' stamp: 'lr 2/26/2009 19:58'!
initializeIn: aComponent on: aRenderer
	self initialize.
	component := aComponent.
	html := aRenderer! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 2/26/2009 09:21'!
renderListPresentation: aPresentation
	| items toShow |
	toShow := aPresentation displayValue.
	items := toShow isCollection
		ifTrue: [ toShow ]
		ifFalse: [ Array with: toShow ].
	items := items ifNil: [ OrderedCollection new ].
	html select
		size: 10;
		list: items;
		labels: aPresentation format;
		selected: aPresentation selection;
		id: (self uuidFor: aPresentation);
		callback: [ :value | aPresentation selection: value ];
		onChange: (html jQuery ajax 
			serializeThis;
			script: [ :script | self updateScript: script ])! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 2/25/2009 15:20'!
renderMondrianPresentation: aMondrianPresentation
	html text: 'mondrian'! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 2/27/2009 10:51'!
renderPane: aPane
	| id |
	html tableData 
		id: (id := self uuidFor: aPane);
		with: [ self renderPaneContent: aPane ].
	aPane whenMatchingPresentationsChanged: [ :ann |
		scripts add: ((html jQuery id: id) html: [ :renderer | 
			html := renderer.
			self renderPaneContent: aPane ]) ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 2/27/2009 11:21'!
renderPaneContent: aPane
	| panes pane |
	panes := aPane matchingPresentations.
	panes isEmpty ifTrue: [ ^ self ].
	pane := properties at: aPane ifAbsentPut: [ panes first ].
	panes size > 1 ifTrue: [
		html unorderedList class: 'tabs'; with: [
			panes do: [ :each |
				html listItem class: 'tabs-current' if: pane = each; with: [ 
					html anchor
						url: 'javascript:void(0)';
						onClick: ((html jQuery id: (self uuidFor: aPane)) load
							html: [ :renderer | 
								html := renderer. 
								properties at: aPane put: each.
								self renderPaneContent: aPane ]);
						with: each title ] ] ] ].
	self render: pane! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 2/27/2009 09:30'!
renderTableLayoutBrowser: aBrowser
	html table class: (self uuidFor: aBrowser); with: [ 
		aBrowser cell isRow
			ifTrue: [ self renderTableLayoutBrowserRow: aBrowser cell ]
			ifFalse: [ self renderTableLayoutBrowserColumn: aBrowser cell ] ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 2/27/2009 10:51'!
renderTableLayoutBrowserColumn: aCell
	html tableRow: [
		aCell children do: [ :each |
			each hasId 
				ifTrue: [ self render: (aCell browser paneNamed: each id) ]
				ifFalse: [ self renderTableLayoutBrowserRow: each ] ] ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 2/27/2009 10:52'!
renderTableLayoutBrowserRow: aCell
	html tableRow: [
		aCell children do: [ :each |
			each hasId 
				ifTrue: [ self render: (aCell browser paneNamed: each id) ]
				ifFalse: [ self renderTableLayoutBrowserColumn: each ] ] ]! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 2/26/2009 20:11'!
renderTextPresentation: aPresentation
	html textArea
		id: (self uuidFor: aPresentation);
		value: aPresentation formatedDisplayValue;
		callback: [ :value | aPresentation text: value ];
		onChange: (html jQuery ajax 
			serializeThis;
			script: [ :script | self updateScript: script ])! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 2/25/2009 15:20'!
renderTreePresentation: aTreePresentation
	html text: 'tree'! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 2/25/2009 15:20'!
renderWorkspacePresentation: aWorkspacePresentation
	html text: 'workspace'! !

!SGLRenderer methodsFor: 'private' stamp: 'lr 2/25/2009 16:19'!
updateScript: aScript
	aScript addAll: scripts.
	scripts := OrderedCollection new! !

!SGLRenderer methodsFor: 'private' stamp: 'lr 2/25/2009 15:11'!
uuidFor: anObject
	| key |
	^ uuid at: anObject ifAbsentPut: [
		[ key := WAExternalID new.
		  uuid includesKey: key ] 
			whileTrue.
	 	key ]! !
SGLFileBrowser initialize!
SGLPackageBrowser initialize!
